package org.jboss.soa.qa.drools.cep

import static switchyard.qa.audit.ProviderAuditor.Property.*

import javax.inject.Inject

import org.jboss.arquillian.container.test.api.Deployment
import org.jboss.arquillian.junit.Arquillian
import org.jboss.arquillian.junit.InSequence
import org.jboss.shrinkwrap.api.spec.JavaArchive
import org.junit.After
import org.junit.Before
import org.junit.Test
import org.junit.runner.RunWith
import org.switchyard.component.bean.Reference

import switchyard.qa.audit.ProviderAuditor
import switchyard.qa.audit.common.AuditService

@RunWith(Arquillian.class)
public class DroolsCEPServiceTest {

	@Inject @Reference
	CEPService service

	@Inject
	AuditService audit

	@Deployment
	def static JavaArchive createDeployment() {
		TestCommons.createDeployment()
	}

	@Before
	def void login() {
		//		TestCommons.login()
		audit.clear()
		audit.auditors = [ProviderAuditor.class]
	}

	@After
	def void logout() {
		//		TestCommons.logout()
	}

	@Test
	public void callService() throws InterruptedException {
		println '@@@@@@ Calling SwitchYard Service from Groovy test'
		System.out.println("@@@@@@ Calling SwitchYard Service")
		Tick t1 = new Tick().setEventName("heartBeat OK tick 1")
		Tick t2 = new Tick().setEventName("heartBeat OK tick 2")
		Tick t3 = new Tick().setEventName("heartBeat NO tick 3")

		service.heartBeat(t1);
		//		Thread.sleep(500);
		//		service.heartBeat(t2);
		//		Thread.sleep(1001);
		//		service.heartBeat(t3);

		Thread.sleep(10000)

		audit.data.each { println it }
		//		new AuditChecker(audit)
		//				.assertService('{urn:switchyard-soa:bean_simple_service:0.1.0}SimpleService')
		//				.assertEquals(CONTENT, '300')
		//			.nextStep()
		//				.assertService('{urn:switchyard-soa:bean_simple_service:0.1.0}SimpleService')
		//				.assertEquals(RESPOND, '301')
	}

	@Test
	@InSequence(999)
	def void cleanRegistry() {
		TestCommons.cleanRegistry(TestCommons.getRegistry(service))
	}


}

